%%%%%%Calculation of the STN for an ET suspension 
%%%%%%%%%%%%%%%%%ET Technology school - Paola Puppo 13/12/2024
close all
clear all
%%%ET Mirror
%%%M:\AnsysWB\ET_Payload_Sapphire.wpj A-D %%%Reference to simulation
%%%Per caricare files
delimiterIn = ' ';
headerlinesIn = 1;

%%Source files
path= 'M:\AnsysWB\Results\ET_Payload\Sapphire\'; %path data file for suspended v3ifoin=SuspET_Sapphire;
ifoin=SuspET_Sapphire;
ifo=ifoin;
Strains=strcat(path,'StrainModes.txt'); %modo(1),EneH(1),EneMir(1),EneAnchors(1),EneSiBoAnchors(1),EneEars(1),EneSiBoEars(1),EneLink(1)
Strain2=strcat(path,'StrainModes_2.txt'); %nmodo(1),modo(1),EneSiBoU(1),EneAnchorsU(1)
Strains_cavo1=strcat(path,'Strains_cavo1.txt'); %modo(1),ECavi(1),ECavo1(1)
Strains_cavo2=strcat(path,'Strains_cavo2.txt'); %modo(1),ECavi(1),ECavo2(1)
Strains_cavo3=strcat(path,'Strains_cavo3.txt'); %modo(1),ECavi(1),ECavo3(1)
Strains_cavo4=strcat(path,'Strains_cavo4.txt'); %modo(1),ECavi(1)
Strains_Mario=strcat(path,'Strains_Mario.txt'); %modo(1),EMario(1),ECavoMario(1)

%%%%%%%%%%%LOAD files%%%%%%%%%%%%%%%%%%%%%%%%
strains=load(Strains);
strains2=load(Strain2);
strain_cavo1=load(Strains_cavo1);
strain_cavo2=load(Strains_cavo2);
strain_cavo3=load(Strains_cavo3);
strain_cavo4=load(Strains_cavo4);
strain_mario=load(Strains_Mario);

%%%%%%%%%%%%%%Definizione parametri
phisibo=0.1;
phimag=1e-5;
phi_mario0=ifo.Suspension.Stage(3).Phi;
Massa=ifo.Suspension.Stage(1).Mass;
Larm=ifo.Infrastructure.Length;
Po=1.1;

Temp=ifo.Constants.Temp;
kb=ifo.Constants.kB;
h=ifo.Constants.h ;
c=ifo.Constants.c;
g=ifo.Constants.g;
alphas=ifo.Materials.Substrate.Alphas ;            % Surface loss limit (ref. 12) 
sigmap=ifo.Materials.Substrate.MirrorSigma;              % Poisson ratio (ref. 4)
Y=ifo.Suspension.Silica.Y;

fns=strains(:,1);
[fs,Is]=sort(fns);
steps=length(fs);
Etots=strains(Is,2);
ws=2*pi.*fs;
% phibulks=c2.*fs.^n;
phibulks=ifo.Materials.Substrate.phi;
PressioneEND=Po; 

%%%%Mirror&SilicaParts SUSPENDED%%%%%%
Emirs=strains(Is,3);
Eanchorss=strains(Is,4); %4 Anchors
Eearss=strains(Is,6); %2 Ears
phimirs=phibulks.*Emirs./Etots;
phianchorss=phibulks.*Eanchorss./Etots;
phiearss=phibulks.*Eearss./Etots;
phi_silicas=phimirs+phianchorss+phiearss;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%Upper Clamps
ESiboUP=strains2(Is,3); %%1 anchorUP
EAnchorsUP=strains2(Is,4); %%4 anchors
phiSiboUP=4*phisibo.*ESiboUP./Etots;   %>>>>>>>>>>>>>>>>>SIBOUP *4
phiAnchorsUP=phibulks.*EAnchorsUP./Etots;

%%%Layers SUSPENDED
ESiboEarss=strains(Is,7); %% 2 ears
ESiboAnchorss=strains(Is,5); %% 1 anchor
ESibos=ESiboEarss+4*ESiboAnchorss; %>>>>>>>>>>>>>>>>>with SIBO*4
phiSiboEarss=phisibo.*ESiboEarss./Etots;
phiSiboAnchorss=4*phisibo.*ESiboAnchorss./Etots;  
phiLayerss=phiSiboEarss+phiSiboAnchorss;

%%%%%%%%%%%Marionetta
 EMario=strain_mario(Is,2);
 EcaviMario=strain_mario(Is,3);
 phib_mario=phi_mario0*EMario./Etots;

 %%%PhiCaviMario
    % Marionette  parameter are loaded. 
m1=ifo.Suspension.Stage(3).Mass; 
LL1=ifo.Suspension.Stage(3).Length;
dd1=ifo.Suspension.Stage(3).WireDiameter;
N1=ifo.Suspension.Stage(3).NWires;
rho1=ifo.Suspension.Stage(3).Rho;
C1=ifo.Suspension.Stage(3).C;
K1=ifo.Suspension.Stage(3).K;
alpha1=ifo.Suspension.Stage(3).Alpha;
beta1=ifo.Suspension.Stage(3).dlnEdT;
phi1=ifo.Suspension.Stage(3).Phi;
ds1=ifo.Suspension.Stage(3).Dissdepth;
E1=ifo.Suspension.Stage(3).Y;
S1=pi*(dd1/2)^2;

% Thermoelastic contribution
T1=(m1+Massa)*g/N1;
Delta1=E1*(alpha1-beta1*T1/(S1*E1)).^2*Temp/(rho1*C1);
tau1=0.0737*rho1*C1*(dd1)^2/K1;
mu=8/dd1;

for i=1:length(fs),
    phith1(i)=Delta1*ws(i)*tau1/(1+ws(i)^2*tau1^2);
end

phiTma1=transpose(phith1+phi1*(1+mu*ds1));
phi_cmario=phiTma1.*EcaviMario./Etots;
phi_mario=phib_mario+phi_cmario;

 fmaxs=length(strains);

 %%%Thermal Cavi
%%%%Cavo1%%%%%; 
    EP(:,1)=strain_cavo1(Is,3);      % L=733mm diam=2.2mm
 
%%%%Cavo2%%%%
    EP2(:,1)=strain_cavo2(Is,3);      % L=733mm diam=2.2mm
    
%%%%Cavo3%%%%%
    EP3(:,1)=strain_cavo3(Is,3);      % L=733mm diam=2.2mm
  
%%%%Cavo4%%%%%
    EP4(:,1)=strain_cavo4(Is,3);      % L=733mm diam=2.2mm

Do=ifo.Suspension.Stage(1).WireDiameter;
L=ifo.Suspension.Stage(1).Length;
    LP(1)=L;
    DP(1)=Do;
    

  %%%PhiCaviTM
    m=ifo.Suspension.Stage(1).Mass; 
    N=ifo.Suspension.Stage(1).NWires;
    alpha=ifo.Suspension.Stage(1).Alpha;
    beta=ifo.Suspension.Stage(1).dlnEdT;
    C=ifo.Suspension.Stage(1).C;
    K=ifo.Suspension.Stage(1).K;
    rho=ifo.Suspension.Stage(1).Rho;
    phi0=ifo.Suspension.Stage(1).Phi/ifo.Suspension.pendulum.weq; %%%>>>>>>>phi suspension
    ds=ifo.Suspension.Stage(1).Dissdepth;
    E0=ifo.Suspension.Stage(1).Y;
   % L=ifo.Suspension.Stage(1).Length;
    %d=ifo.Suspension.Stage(1).WireDiameter;
    
    ws=(2 * pi * fs);
    Tens=m*g/N;

   for i=1:1;
    Ro=DP(i)/2;
    S=pi*Ro^2;
    Lo=LP(i);
    II=pi/4*Ro^4;
    tau=0.0737*rho*C*(2*Ro)^2/K;
    kela=(Tens/E0/II/2)^0.5;
    kelal=kela*Lo;
    rhou=rho*pi*Ro^2;
    Delta=E0*(alpha-beta*Tens/(S*E0))^2*Temp/(rho*C);
    mu=4/Ro;
    phiSTi=phi0*(1+mu*ds);    
     nfreqs=length(ws);
    for j=1:nfreqs;
    phithT(j,i)=Delta*tau*ws(j)/(1+ws(j)^2*tau^2); 
    phiT(j,i)=phiSTi+0*phithT(j,i);
    phiTf(j)=phiSTi+0*phithT(j,1); %%%Check
    Wloss(j,i)=phiT(j,i)*EP(j,i); 
    Wloss2(j,i)=phiT(j,i)*EP2(j,i);
    Wloss3(j,i)=phiT(j,i)*EP3(j,i);
    Wloss4(j,i)=phiT(j,i)*EP4(j,i);
    
    end
   end

   %%%%%%%%%%%%%%%Thermal cavi
  
    
for count1=1:nfreqs,
       %%Con spezzoni di filo%%%%%%%%%
    WcaviTM(count1)=Wloss(count1,1);
    WcaviTM2(count1)=Wloss2(count1,1);
    WcaviTM3(count1)=Wloss3(count1,1);
    WcaviTM4(count1)=Wloss4(count1,1);

    WcaviTMspezht(count1)=WcaviTM(count1)+WcaviTM2(count1)+ WcaviTM3(count1)+ WcaviTM4(count1);
end
    WcaviTMspezh=transpose(WcaviTMspezht);

    for count1=1:length(ws);
   YbSuspMirror(count1)=8*kb*Temp*WcaviTMspezh(count1)/ws(count1)/PressioneEND^2;  %%Cavi Specchio
   
    YbLayerss(count1)=8*kb*Temp*phiLayerss(count1)*Etots(count1)/PressioneEND^2/ws(count1);  %%Thermal sibo ears + anchors dw
   
    YbSiBoAnchorss(count1)=8*kb*Temp*phiSiboAnchorss(count1)*Etots(count1)/PressioneEND^2/ws(count1); %%Thermal SiBoAnchors dw
    YbSiBoEarss(count1)=8*kb*Temp*phiSiboEarss(count1)*Etots(count1)/PressioneEND^2/ws(count1); %%Thermal ears
     
    YbSilicas(count1)=8*kb*Temp*phi_silicas(count1)*Etots(count1)/PressioneEND^2/ws(count1);   %%Thermal silica Down (Mirr+Anchors+Ears)
    
    YbSiBoUP(count1)=8*kb*Temp*phiSiboUP(count1)*Etots(count1)/PressioneEND^2/ws(count1); %%Thermal sibo Anchors UP
    YbAnchorsUP(count1)=8*kb*Temp*phiAnchorsUP(count1)*Etots(count1)/PressioneEND^2/ws(count1); %%Thermal Anchors UP
   Ymario(count1)=8*kb*Temp*phib_mario(count1)*Etots(count1)/PressioneEND^2/ws(count1); %%Thermal Bulk Mario
   Ycmario(count1)=8*kb*Temp*phi_cmario(count1)*Etots(count1)/PressioneEND^2/ws(count1); %%Thermal Cavi Mario
   
  
   Ysusptot(count1)=YbSuspMirror(count1)+Ycmario(count1); %%Thermal cavi Mirr+mario
    end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%SuspThermGwinc
f=logspace(log10(.1),log10(fs(length(fs))),3000);
[XSusp,Deltag,dil]=suspR_ET(f,ifo);   

%Thermal total
for count1=1:length(fs)
Ytot(count1)=Ysusptot(count1)+Ymario(count1)+YbSilicas(count1)+YbSiBoAnchorss(count1)+YbSiBoEarss(count1)+YbAnchorsUP(count1)+YbSiBoUP(count1);
end
close all

figure(1)
a=loglog(f,sqrt(XSusp)/2)
a.LineWidth=2;
a.Color='green';
hold on
b=loglog(fs(3:length(fs)),sqrt(Ysusptot(3:length(fs)))/Larm)
b.LineWidth=2;
b.Color='red';
hold off
xlim([f(1),f(length(f))])
legend('STN Analytical','STN FEM')
fontname("Century Gothic")
fontsize(11,"points")
title('STN  (1/sqrt(Hz))')

